---
title: Using the Web Storage API
slug: Web/API/Web_Storage_API/Using_the_Web_Storage_API
tags:
  - API
  - Guide
  - Storage
  - Web Storage API
  - localStorage
  - sessionStorage
---
<div>{{DefaultAPISidebar("Web Storage API")}}</div>

<p><span class="seoSummary">The Web Storage API provides mechanisms by which browsers can securely store key/value pairs.</span></p>

<p>This article provides a walkthrough of how to make use of this technology.</p>

<h2 id="Basic_concepts">Basic concepts</h2>

<p>Storage objects are simple key-value stores, similar to objects, but they stay intact through page loads. The keys and the values are always strings (note that, as with objects, integer keys will be automatically converted to strings). You can access these values like an object, or with the {{domxref("Storage.getItem()")}} and {{domxref("Storage.setItem()")}} methods. These three lines all set the (same) colorSetting entry:</p>

<pre class="brush: js notranslate" style="white-space: pre;">localStorage.colorSetting = '#a4509b';
localStorage['colorSetting'] = '#a4509b';
localStorage.setItem('colorSetting', '#a4509b');</pre>

<div class="note">
<p><strong>Note</strong>: It's recommended to use the Web Storage API (<code>setItem</code>, <code>getItem</code>, <code>removeItem</code>, <code>key</code>, <code>length</code>) to prevent the <a href="http://www.2ality.com/2012/01/objects-as-maps.html">pitfalls</a> associated with using plain objects as key-value stores.</p>
</div>

<p>The two mechanisms within Web Storage are as follows:</p>

<ul>
 <li><strong><code>sessionStorage</code></strong> maintains a separate storage area for each given origin that's available for the duration of the page session (as long as the browser is open, including page reloads and restores).</li>
 <li><strong><code>localStorage</code></strong> does the same thing, but persists even when the browser is closed and reopened.</li>
</ul>

<p>These mechanisms are available via the {{domxref("Window.sessionStorage")}} and {{domxref("Window.localStorage")}} properties (to be more precise, in supporting browsers the <code>Window</code> object implements the <code>WindowLocalStorage</code> and <code>WindowSessionStorage</code> objects, which the <code>localStorage</code> and <code>sessionStorage</code> properties are members of) — invoking one of these will create an instance of the {{domxref("Storage")}} object, through which data items can be set, retrieved, and removed. A different Storage object is used for the <code>sessionStorage</code> and <code>localStorage</code> for each origin — they function and are controlled separately.</p>

<p>So, for example, initially calling <code>localStorage</code> on a document will return a {{domxref("Storage")}} object; calling <code>sessionStorage</code> on a document will return a different {{domxref("Storage")}} object. Both of these can be manipulated in the same way, but separately.</p>

<h2 id="Feature-detecting_localStorage">Feature-detecting localStorage</h2>

<p>To be able to use localStorage, we should first verify that it is supported and available in the current browsing session.</p>

<h3 id="Testing_for_availability">Testing for availability</h3>

<div class="notecard note">
<p>Note: This API is available in current versions of all major browsers. Testing for availability is necessary only if you must support very old browsers, such as Internet Explorer 6 or 7, or in the limited circumstances described below.</p>
</div>

<p>Browsers that support localStorage have a property on the window object named <code>localStorage</code>. However, just asserting that that property exists may throw exceptions. If the <code>localStorage</code> object does exist, there is still no guarantee that the localStorage API is actually available, as various browsers offer settings that disable localStorage. So a browser may <em>support</em> localStorage, but not make it <em>available</em> to the scripts on the page.</p>

<p>For example, Safari browser in Private Browsing mode gives us an empty localStorage object with a quota of zero, effectively making it unusable. Conversely, we might get a legitimate <code>QuotaExceededError</code>, which means that we've used up all available storage space, but storage <em>is</em> actually <em>available</em>. Our feature detection should take these scenarios into account.</p>

<p>Here is a function that detects whether localStorage is both supported and available:</p>

<pre class="brush: js notranslate">function storageAvailable(type) {
    var storage;
    try {
        storage = window[type];
        var x = '__storage_test__';
        storage.setItem(x, x);
        storage.removeItem(x);
        return true;
    }
    catch(e) {
        return e instanceof DOMException &amp;&amp; (
            // everything except Firefox
            e.code === 22 ||
            // Firefox
            e.code === 1014 ||
            // test name field too, because code might not be present
            // everything except Firefox
            e.name === 'QuotaExceededError' ||
            // Firefox
            e.name === 'NS_ERROR_DOM_QUOTA_REACHED') &amp;&amp;
            // acknowledge QuotaExceededError only if there's something already stored
            (storage &amp;&amp; storage.length !== 0);
    }
}</pre>

<p>And here is how you would use it:</p>

<pre class="brush: js notranslate">if (storageAvailable('localStorage')) {
  // Yippee! We can use localStorage awesomeness
}
else {
  // Too bad, no localStorage for us
}</pre>

<p>You can test for sessionStorage instead by calling <code>storageAvailable('sessionStorage')</code>.</p>

<p>See here for a <a href="https://gist.github.com/paulirish/5558557">brief history of feature-detecting localStorage</a>.</p>

<h2 id="Example">Example</h2>

<p>To illustrate some typical web storage usage, we have created an example, imaginatively called <strong>Web Storage Demo</strong>. The <a href="https://mdn.github.io/dom-examples/web-storage/">landing page</a> provides controls that can be used to customize the color, font, and decorative image:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/9685/landing.png" style="display: block; height: 482px; margin: 0px auto; width: 700px;">When you choose different options, the page is instantly updated; in addition, your choices are stored in <code>localStorage</code>, so that when you leave the page and load it again, later on, your choices are remembered.</p>

<p>We have also provided an <a href="https://mdn.github.io/dom-examples/web-storage/event.html">event output page</a> — if you load this page in another tab, then make changes to your choices in the landing page, you'll see the updated storage information outputted as a {{domxref("StorageEvent")}} is fired.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/9687/event-output.png" style="display: block; height: 482px; margin: 0px auto; width: 700px;"></p>

<div class="note">
<p><strong>Note</strong>: As well as viewing the example pages live using the above links, you can also <a href="https://github.com/mdn/dom-examples/tree/master/web-storage">check out the source code</a>.</p>
</div>

<h3 id="Testing_whether_your_storage_has_been_populated">Testing whether your storage has been populated</h3>

<p>To start with, in <a href="https://github.com/mdn/dom-examples/blob/master/web-storage/main.js">main.js</a>, we test whether the storage object has already been populated (i.e., the page was previously accessed):</p>

<pre class="brush: js notranslate">if(!localStorage.getItem('bgcolor')) {
  populateStorage();
} else {
  setStyles();
}</pre>

<p>The {{domxref("Storage.getItem()")}} method is used to get a data item from storage; in this case, we are testing to see whether the <code>bgcolor</code> item exists; if not, we run <code>populateStorage()</code> to add the existing customization values to the storage. If there are already values there, we run <code>setStyles()</code> to update the page styling with the stored values.</p>

<p><strong>Note</strong>: You could also use {{domxref("Storage.length")}} to test whether the storage object is empty or not.</p>

<h3 id="Getting_values_from_storage">Getting values from storage</h3>

<p>As noted above, values can be retrieved from storage using {{domxref("Storage.getItem()")}}. This takes the key of the data item as an argument, and returns the data value. For example:</p>

<pre class="brush: js notranslate">function setStyles() {
  var currentColor = localStorage.getItem('bgcolor');
  var currentFont = localStorage.getItem('font');
  var currentImage = localStorage.getItem('image');

  document.getElementById('bgcolor').value = currentColor;
  document.getElementById('font').value = currentFont;
  document.getElementById('image').value = currentImage;

  htmlElem.style.backgroundColor = '#' + currentColor;
  pElem.style.fontFamily = currentFont;
  imgElem.setAttribute('src', currentImage);
}</pre>

<p>Here, the first three lines grab the values from local storage. Next, we set the values displayed in the form elements to those values, so that they keep in sync when you reload the page. Finally, we update the styles/decorative image on the page, so your customization options come up again on reload.</p>

<h3 id="Setting_values_in_storage">Setting values in storage</h3>

<p>{{domxref("Storage.setItem()")}} is used both to create new data items, and (if the data item already exists) update existing values. This takes two arguments — the key of the data item to create/modify, and the value to store in it.</p>

<pre class="brush: js notranslate">function populateStorage() {
  localStorage.setItem('bgcolor', document.getElementById('bgcolor').value);
  localStorage.setItem('font', document.getElementById('font').value);
  localStorage.setItem('image', document.getElementById('image').value);

  setStyles();
}</pre>

<p>The <code>populateStorage()</code> function sets three items in local storage — the background color, font, and image path. It then runs the <code>setStyles()</code> function to update the page styles, etc.</p>

<p>We've also included an <code>onchange</code> handler on each form element so that the data and styling are updated whenever a form value is changed:</p>

<pre class="brush: js notranslate">bgcolorForm.onchange = populateStorage;
fontForm.onchange = populateStorage;
imageForm.onchange = populateStorage;</pre>

<h3 id="Responding_to_storage_changes_with_the_StorageEvent">Responding to storage changes with the StorageEvent</h3>

<p>The {{domxref("StorageEvent")}} is fired whenever a change is made to the {{domxref("Storage")}} object (note that this event is not fired for sessionStorage changes). This won't work on the same page that is making the changes — it is really a way for other pages on the domain using the storage to sync any changes that are made. Pages on other domains can't access the same storage objects.</p>

<p>On the events page (see <a href="https://github.com/mdn/dom-examples/blob/master/web-storage/event.js">events.js</a>) the only JavaScript is as follows:</p>

<pre class="brush: js notranslate">window.addEventListener('storage', function(e) {
  document.querySelector('.my-key').textContent = e.key;
  document.querySelector('.my-old').textContent = e.oldValue;
  document.querySelector('.my-new').textContent = e.newValue;
  document.querySelector('.my-url').textContent = e.url;
  document.querySelector('.my-storage').textContent = JSON.stringify(e.storageArea);
});</pre>

<p>Here we add an event listener to the <code>window</code> object that fires when the {{domxref("Storage")}} object associated with the current origin is changed. As you can see above, the event object associated with this event has a number of properties containing useful information — the key of the data that changed, the old value before the change, the new value after that change, the URL of the document that changed the storage, and the storage object itself (which we've stringified so you can see its content).</p>

<h3 id="Deleting_data_records">Deleting data records</h3>

<p>Web Storage also provides a couple of simple methods to remove data. We don't use these in our demo, but they are very simple to add to your project:</p>

<ul>
 <li>{{domxref("Storage.removeItem()")}} takes a single argument — the key of the data item you want to remove — and removes it from the storage object for that domain.</li>
 <li>{{domxref("Storage.clear()")}} takes no arguments, and empties the entire storage object for that domain.</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'webstorage.html#webstorage')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="Window.localStorage"><code>Window.localStorage</code></h3>

<p>{{Compat("api.Window.localStorage")}}</p>

<h3 id="Window.sessionStorage"><code>Window.sessionStorage</code></h3>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.Window.sessionStorage")}}</p>

<p>All browsers have varying capacity levels for both localStorage and sessionStorage. Here is a <a class="external" href="http://dev-test.nemikor.com/web-storage/support-test/">detailed rundown of all the storage capacities for various browsers</a>.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Storage_API">Web Storage API landing page</a></li>
</ul>
